Normally Inherited fields are not inherited upon host registration
Status: Closed   

Priority: Normal   

Assignee:    

Category: Host registration   

Target version: 2.5.1   

Difficulty:  Fixed in Releases: 2.5.1, 3.0.0

Triaged: No Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/8539

  

Description

If I pick a host group during the host registration, values we normally inherit from hostgroup are not inherited, e.g. puppet

environment, puppet proxy, puppet ca proxy.

Related issues:

Related to Foreman - Bug #36207: Host Group Puppet Settings are not inherited New

Has duplicate Foreman - Bug #32304: Register host does not use puppet setting... Closed

Associated revisions

Revision e60069e1 - 06/01/2021 12:52 PM - Leos Stejskal

Fixes #32457 - Register host & apply inherited attributes (#8539)

History

#1 - 04/29/2021 12:33 PM - Marek Hulán

The reason is, when host is created normally, we apply inherited attributes thanks to

https://github.com/theforeman/foreman/blob/c03c4a44a8c7891aeb470a2fde3f486199299177/app/models/host/managed.rb#L77-L80

The registration skips this and calls directly assign attributes

https://github.com/theforeman/foreman/blob/develop/app/controllers/api/v2/registration_controller.rb#L110-L119

That should be changed so the inheritance logic works like when the new host is created through the form.

#2 - 04/29/2021 08:37 PM - Damon Maria

- Has duplicate Bug #32304: Register host does not use puppet settings from host group added

#3 - 05/20/2021 07:35 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/8539 added

#4 - 06/01/2021 12:52 PM - The Foreman Bot

- Fixed in Releases 3.0.0 added

#5 - 06/01/2021 01:02 PM - Leos Stejskal

- Status changed from Ready For Testing to Closed

Applied in changeset foreman|e60069e12d7c1cf59394ae2d125d36f53f755dfd.

#6 - 06/03/2021 08:23 AM - Tomer Brisker

- Target version set to 2.5.1
https://github.com/theforeman/foreman/blob/c03c4a44a8c7891aeb470a2fde3f486199299177/app/models/host/managed.rb#L77-L80
https://github.com/theforeman/foreman/blob/develop/app/controllers/api/v2/registration_controller.rb#L110-L119
https://projects.theforeman.org/projects/foreman/repository/foreman/revisions/e60069e12d7c1cf59394ae2d125d36f53f755dfd


#7 - 06/03/2021 10:25 AM - Tomer Brisker

- Fixed in Releases 2.5.1 added

#8 - 03/17/2023 09:38 AM - Lioh Moeller

This issue is still present on Foreman 3.5.1.

Steps to reproduce:

- Create a Host Group

- Select 'Puppet Proxy', 'Puppet CA' and 'Environment' from the relevant Pull-Down-Menus on the Host Group

- Create a Global Registration Template associated with the newly created Host Group

- Register a client using the Global Registration template

The client is registered, but Puppet Parameters from the Host Group are not adopted, leading to empty ‘Environment’ ‘Puppet Proxy’ and ‘Puppet CA

Proxy’ on the host object and a puppet.conf on the client which looks like this:

[main]

[agent]

pluginsync      = true

report          = true

certname        = my.host.tld

 The issue does not occur if the host object already exists and Puppet settings are defined on the host object.

A partial workaround, still leading to a non-functional result, is to define puppet_ca_server and puppet_server as Parameters on the hostgroup. In this

case server and ca are written correctly, but environment not. Trying to set the host_puppet_environment  parameter manually on the host group, still

leads to the same result (variable empty)

#9 - 03/17/2023 09:59 AM - Ewoud Kohl van Wijngaarden

- Subject changed from Normally Inherited fields are not inherited upon host registreation to Normally Inherited fields are not inherited upon host

registration

#10 - 03/24/2023 06:08 AM - Lioh Moeller

- Related to Bug #36207: Host Group Puppet Settings are not inherited added
